// David Pilling 1st February 2016
// HC-SR04 with STM32 using interrupts


#include <stdarg.h>

void pr(char *fmt, ... ){
        char buf[128]; // resulting string limited to 128 chars
        va_list args;
        va_start (args, fmt );
        vsnprintf(buf, 128, fmt, args);
        va_end (args);
        Serial.println(buf);

}


#define pinLED PC13
#define pinEcho PB6
#define pinTrigger PA7

void setup() 
{
 Serial.begin(9600);
 pinMode(pinLED, OUTPUT);
 pinMode(pinEcho, INPUT);
 pinMode(pinTrigger, OUTPUT);

 attachInterrupt(pinEcho, changeEcho, CHANGE);
}


volatile unsigned long microtime;

void changeEcho(void)
{
 microtime=micros();
}



void loop() 
{
 digitalWrite(pinLED, HIGH);
 delay(100);
 digitalWrite(pinLED, LOW);
 delay(100);

 digitalWrite(pinTrigger, 1);   
 delayMicroseconds(10); 
 digitalWrite(pinTrigger, 0); 

 unsigned long timeout=millis()+100;
 unsigned long oldmicrotime=microtime;
 
 while(1)
 {
  if(oldmicrotime!=microtime) break;
  if(millis()>timeout) break;
 }

 unsigned long timestart=oldmicrotime=microtime;

 while(1)
 {
  if(oldmicrotime!=microtime) break;
  if(millis()>timeout) break;
 }

 pr("time %lu",microtime-timestart);
}

